package de.abm.bug;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.io.IOException;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.rendering.PDFRenderer;

public class App implements Runnable {
    
    private final JFrame jFrame;

    private final static class PDFView extends JComponent {
        private static final long serialVersionUID = 1L;

        @Override
        public void paint(final Graphics g) {

            final Graphics2D g2 = (Graphics2D) g;
            try {
                final int r = 20;
                final AffineTransform transform = g2.getTransform();
                g2.clip(new Rectangle(r, r));
                final PDDocument pdDocument = PDDocument.load(App.class.getResourceAsStream("/de/abm/bug/good.pdf"));
                final PDFRenderer pdfRenderer = new org.apache.pdfbox.rendering.PDFRenderer(pdDocument);
                pdfRenderer.renderPageToGraphics(0, g2);
                g2.setTransform(transform);
                g2.setColor(Color.black);
                g2.drawRect(0, 0, r, r);
            } catch (final IOException e) {
                throw new RuntimeException(e);
            }
        }
    }


    public App() {
        jFrame = new JFrame();
        jFrame.add(new PDFView());
        jFrame.setSize(new Dimension(500, 500));
    }


    @Override
    public void run() {
        jFrame.setVisible(true);
    }
    
    public static void main(final String[] args) {
        final App app = new App();
        SwingUtilities.invokeLater(app);
    }

}
